import 'dart:async';
import 'package:action_consolidator/action_consolidator.dart';

main() {

  // Create the action consolidator
  var consolidator = new ActionConsolidator<String>();

  // S simple mock async action which would behave like a memcache get
  var asyncAction = (String key) {
    return () {
      print('** Running the async mock memcache call for ${key}');
      return new Future.delayed(new Duration(seconds:2), () => "** Got ${key}");
    };
  };

  // Call `asyncAction` 3 times via the consolidator, it should only
  // get ran once, but should return 3 times
  var future1 = consolidator.dedupRun("user:joe", asyncAction("user:joe"));
  var future2 = consolidator.dedupRun("user:joe", asyncAction("user:joe"));
  var future3 = consolidator.dedupRun("user:joe", asyncAction("user:joe"));
  future1.then(print);
  future2.then(print);
  future3.then(print);

  // Call interweaved actions, they should queue properly
  var future4 = consolidator.dedupRun("user:moe", asyncAction("user:moe"));
  var future5 = consolidator.dedupRun("user:bob", asyncAction("user:bob"));
  var future6 = consolidator.dedupRun("user:moe", asyncAction("user:moe"));
  var future7 = consolidator.dedupRun("user:bob", asyncAction("user:bob"));
  future4.then(print);
  future5.then(print);
  future6.then(print);
  future7.then(print);
}